Merge v8.0 into master
[osm/tests.git] / robot-systest / run_test.sh
1 #!/usr/bin/env bash
2
3 ##
4 # Copyright 2020 ATOS
5 #
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License");
9 # you may not use this file except in compliance with the License.
10 # You may obtain a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS,
16 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
17 # See the License for the specific language governing permissions and
18 # limitations under the License.
19 ##
20
21 cat /dev/zero | ssh-keygen -q -N "" > /dev/null
22
23 install_osmclient(){
24 echo -e "\nInstalling osmclient ${OSMCLIENT}"
25 python3 -m pip install git+https://osm.etsi.org/gerrit/osm/osmclient@${OSMCLIENT}
26 }
27
28 download_packages(){
29 echo -e "\nDownloading packages ${PACKAGES}"
30 rm -rf ${PACKAGES_FOLDER}
31 git clone https://osm.etsi.org/gitlab/vnf-onboarding/osm-packages.git ${PACKAGES_FOLDER} && (cd ${PACKAGES_FOLDER} && \
32 git checkout ${PACKAGES})
33 }
34
35 create_vim(){
36
37 attempts=3
38 while [ $attempts -ge 0 ] ; do
39 echo -e "\n$( date '+%F_%H:%M:%S' ) Creating VIM ${VIM_TARGET}"
40 osm vim-create --name ${VIM_TARGET} --user ${OS_USERNAME} --password ${OS_PASSWORD} --tenant ${OS_PROJECT_NAME} \
41 --auth_url ${OS_AUTH_URL} --account_type openstack --description vim \
42 --config "{management_network_name: ${VIM_MGMT_NET}, dataplane_physical_net: ${DATAPLANE:-physnet2}}" || true
43 STATUS="PROCESSING"
44 i=0
45 while [[ ${STATUS} != "ENABLED" ]]
46 do
47 ((i++))
48 if [[ $i -eq 5 ]]; then
49 echo "VIM stuck in PROCESSING after 50 seconds"
50 osm vim-delete ${VIM_TARGET}
51 sleep 5
52 break
53 fi
54 sleep 10
55 STATUS=`osm vim-list --long | grep ${VIM_TARGET} | awk '{print $9}'`
56 done
57 if [[ ${STATUS} = "ENABLED" ]] ; then
58 break
59 fi
60 ((attempts--))
61 done
62
63 if [ $attempts -lt 0 ] ; then
64 echo "VIM failed to enter ENABLED state"
65 exit 1
66 fi
67 }
68
69
70 PARAMS=""
71
72 while (( "$#" )); do
73 case "$1" in
74 -t|--testingtags)
75 TEST=$2
76 shift 2
77 ;;
78 -p|--packagesbranch)
79 PACKAGES=$2 && download_packages
80 shift 2
81 ;;
82 -o|--osmclientversion)
83 OSMCLIENT=$2 && install_osmclient
84 shift 2
85 ;;
86 -c|--createvim)
87 create_vim
88 shift 1
89 ;;
90 -h|--help)
91 echo "OSM TESTS TOOL
92
93 Usage:
94 docker run --rm=true -t osmtests --env-file <env_file> \\
95 -v <path_to_reports>:/reports osmtests \\
96 -v <path_to_clouds.yaml>:/robot-systest/clouds.yaml \\
97 -v <path_to_kubeconfig>:/root/.kube/config \\
98 -o <osmclient_version> \\
99 -p <package_branch> \\
100 -t <testing_tags>
101
102 Options:
103 --env-file: It is the environmental file where is described the OSM target and VIM
104 -o <osmclient_version> [OPTIONAL]: It is used to specify a particular osmclient version. Default: latest
105 -p <package_branch> [OPTIONAL]: OSM packages repository branch. Default: master
106 -t <testing_tags> [OPTIONAL]: Robot tests tags. [sanity, regression, particular_test]. Default: sanity
107 -c To create a VIM for the tests
108
109 Volumes:
110 <path_to_reports> [OPTIONAL]: It is the absolute path to reports location in the host
111 <path_to_clouds.yaml> [OPTIONAL]: It is the absolute path to the clouds.yaml file in the host
112 <path_to_kubeconfig> [OPTIONAL]: It is the kubeconfig file to be used for k8s clusters"
113
114 exit 0
115 ;;
116 -*|--*=)
117 echo "Error: Unsupported flag $1" >&2
118 exit 1
119 ;;
120 *)
121 PARAMS="$PARAMS $1"
122 shift
123 ;;
124 esac
125 done
126
127 eval set -- "$PARAMS"
128
129 if [[ -n "$BRANCH_NAME" ]]; then
130 PACKAGES=$BRANCH_NAME && download_packages
131 OSMCLIENT=$BRANCH_NAME && install_osmclient
132 fi
133
134 if [[ -z "${TEST}" ]]; then
135 printf "Test not provided. \nRunning default test: sanity\n"
136 TEST="sanity"
137 fi
138
139 if [[ -n "${TEST}" ]]; then
140 robot -d ${ROBOT_DEVOPS_FOLDER}/reports -i ${TEST} ${ROBOT_DEVOPS_FOLDER}/testsuite/
141 exit 0
142 else
143 echo "Wrong test provided"
144 exit 1
145 fi
146
147 exit 1